#define TASKNAME "war"
#include <cstdio>
#include <iostream>
#include <fstream>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <cctype>
#include <cstdlib>
#include <cassert>
#include <functional>
#include <iomanip>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <vector>
 
#define EPS (1e-9)
#define INF (int(1e9))
#define INFLONG ((long long)(1e18))
#define sqr(a) ((a) * (a))
#define all(a) (a).begin(), (a).end()
#define zero(a) memset(a, 0, sizeof(a))
#define abs(a) (((a) < 0) ? -(a) : (a))
#define sz(a) (int)a.size()
#define fst first
#define snd second
#define y1 osrughosduvgarligybakrybrogvba
#define y0 aosfigdalrowgyalsouvgrlvygalri                               
#define mp make_pair
#define pb push_back
#define next dlkjdslfkdj
#define prev dsdflksdfjl
#define hash lkdfjldskfj
#define pi 3.1415926535897932384626433832795
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
 
using namespace std;
 
typedef long long ll;
typedef long double ld;
typedef vector <int> vi;
typedef vector <vi> vvi;
typedef vector <bool> vb;
typedef vector <ll> vll;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;
typedef pair <ll, int> pli;
typedef pair <int, ll> pil;
typedef vector <pii> vpii;

int main()
{
  freopen(TASKNAME".in", "r", stdin);
  freopen(TASKNAME".out", "w", stdout);
  int n, m, t;
  scanf("%d%d%d", &n, &m, &t);
  vi k(n);
  for (int i = 0; i < n; i++)
    scanf("%d", &k[i]);
  vvi gr(n);
  for (int i = 0; i < m; i++)
  {
    int a, b;
    scanf("%d%d", &a, &b);
    --a, --b;
    gr[a].pb(b);
    gr[b].pb(a);
  }
  int s, w;
  scanf("%d%d", &s, &w);
  --s;

  int q[n];
  int start = 0, end = 0;
  q[end++] = s;
  vi d(n, INF);
  d[s] = 0;
  while (start < end)
  {
    int v = q[start++];
    for (int i = 0; i < sz(gr[v]); i++)
      if (d[gr[v][i]] > d[v] + 1)
        d[gr[v][i]] = d[v] + 1, q[end++] = gr[v][i];
  }
  vi cnt(m + 1, 0);
  for (int i = 0; i < n; i++)
    if (d[i] != INF)
      cnt[d[i]] += k[i];

  int day = 0;
  int vampires = 0;
  while (1)
  {
    if (day <= m)
      vampires += cnt[day];
    int killed = min(t, min(vampires, w));
    w -= killed; 
    vampires -= killed;
    if (!vampires || !w)
      break;
    ++day;
  }
  puts((!vampires && w) ? "Werewolves win" : "Vampires win");
  return 0;
}

